/*
fillchk.cpp: scan for repetitions of a single byte (file corruption)
2019-10-24,  vin <irc.rizon.net>,  MIT-licensed

this impl:
  23 MiB/s ε=ε=ε=┌( ﾟ ヮﾟ)ﾉ

see also:
  https://ocv.me/dev/?fillchk.c
  https://ocv.me/dev/?fillchk.cpp
  https://ocv.me/dev/?fillchk.py
  https://ocv.me/dev/?fillchk.pl
  https://ocv.me/dev/?fillchk.go
  https://ocv.me/dev/?fillchk.lua
*/

#include <iostream>
#include <ios>
#include <iomanip>

// "from %08lx to %08lx, %02x seen 0x%lx / %lud times\x1b[J\n"
void report(char ch, uint64_t p1, uint64_t p2) {
    std::cout << "from "
              << std::setfill('0') << std::setw(8) << std::hex
              << p1
              << " to "
              << p2
              << ", "
              << std::setw(2)
              << (int)ch
              << " seen 0x"
              << std::setw(0)
              << (p2 - p1)
              << " / "
              << std::dec
              << (p2 - p1)
              << "d times\x1b[J\n";
}

int main(void) {
    char c;
    char c0 = 0;
    uint64_t pos = 0;
    uint64_t p0 = 0;
    for (;;) {
        std::cin >> c;
        if (std::cin.eof())
            break;
        if (c == c0)
            continue;
        if (pos - p0 >= 0x400)
            report(c0, p0, pos);
        p0 = pos;
        c0 = c;
        pos++;
    }
    if (pos - p0 >= 0x400)
        report(c0, p0, pos);
}
